#include "scfunc.h"
#include <sqobject.h>
#include <AS3.h>

#include "sqwrapper.h"

// ĂѕԂp
static AS3Variant scfuncClass;            // ĂѕԂpNX
static sqobject::ObjectInfo scfuncTable; // Squirrel̏Ǘe[u

/*
 * FlasȟĂяop
 * : ̃IuWFNg
 * : ̔z
 */
static AS3_Val squirrelCaller(void *data, AS3_Val p)
{
	AS3Variant result;
	AS3_Acquire(p);
	AS3Variant params(p);
	AS3Variant key  = params.get(0);
	sqobject::ObjectInfo info = scfuncTable.get((const char*)key);
	if (info.isArray()) {
		sqobject::ObjectInfo self = info.get(0);
		sqobject::ObjectInfo func = info.get(1);
		if (self.isNull() || func.isNull()) {
			scfuncTable.deleteslot((const char*)key);
		} else {
			HSQUIRRELVM vm = sqobject::getGlobalVM();
			func.push(vm); // func
			
			// 
			AS3Variant args = params.get(1);
			int num = 1;
			self.push(vm); // this
			int len = args.get("length");
			for (int i=0; i<len; i++) {
				AS3Variant arg = args.get(i);
				sq_pushvariant(vm, arg);
				num++;
			}

			if (SQ_SUCCEEDED(sq_call(vm, num, SQTrue, SQTrue))) {
				result = createVariant(vm, -1);
				sq_pop(vm, 1); // result
			}
			sq_pop(vm, 1); // func
		}
	}
	return result.getObj();
}

/**
 * squirrel̃t@NVێ Flash ̃\bhN[W𐶐
 * SquirrelFunctionNX̃\bhN[WԂ܂
 * @param v squirrelVM
 * @parma idx ϊΏۂ̃CfbNX
 */
AS3Variant
createSCFunction(HSQUIRRELVM v, SQInteger idx)
{
	sqobject::ObjectInfo self;
	self.getStackWeak(v,1);
	sqobject::ObjectInfo func;
	func.getStackWeak(v,idx);

	// t@NVi[񐶐
	sqobject::ObjectInfo info;
	info.initArray();
	info.append(self);
	info.append(func);

	// ʗp̃L[擾
	info.push(v);
	sq_tostring(v,-1);
	const char *key;
	sq_getstring(v, -1, &key);
	// squirrelɃe[uo^
	scfuncTable.create(key, info);
	AS3Variant askey(key);
	sq_pop(v,2);

	AS3Variant instance = scfuncClass.createInstance(askey);
	return instance.get("func");
}

/**
 * Ǘ񏉊
 */
void
scfunc_init()
{
	AS3Variant caller(AS3_Function(NULL,squirrelCaller));
	AS3Variant::createFunction(APPNAMESPACE "setSquirrelCaller").call(caller);
	scfuncClass = AS3Variant::createClass(APPNAMESPACE "SquirrelFunction");
	scfuncTable.initTable();
}

/**
 * scfuncTable |BQƂɂȂĂ܂Ăj
 */
void
scfunc_update()
{
	if (scfuncTable.len() > 0) {
		HSQUIRRELVM v = sqobject::getGlobalVM();
		sq_newtable(v); // ʊi[p
		scfuncTable.push(v); // p
		sq_pushnull(v); // repeat
		while (SQ_SUCCEEDED(sq_next(v,-2))) {
			sqobject::ObjectInfo info(v,-1);
			if (info.isArray() && !info.get(0).isNull() && !info.get(1).isNull()) {
				sq_newslot(v,-5,SQFalse);
			} else {
				sq_clear(v, -1);
				sq_pop(v,2);
			}
		}
		sq_pop(v,2);  // repeat, table
		scfuncTable.clearData();
		scfuncTable.getStack(v, -1); // new table
		sq_pop(v,1);
	}
}

/**
 * Ǘj
 */
void
scfunc_done()
{
	scfuncTable.clearData();
	scfuncTable.clear();
	scfuncClass.clear();
	AS3Variant::createFunction(APPNAMESPACE "removeSquirrelCaller").call();
}
