// support functions

/**
 * ActionScript type checker
 */
public function getType(value:*):int
{
	var type:String = typeof value;
	if (type == "undefined") {
		return 0;
	} else if (type == "null") {
		return 1;
	} else if (type == "boolean") {
		return 2;
	} else if (type == "function") {
		return 3;
	} else if (type == "number") {
		return value is int || value is uint ? 4 : 5;
	} else if (type == "object") {
		return value == null ? 1 : 6;
	} else if (type == "string") {
		return 7;
	} else if (type == "xml") {
		return 8;
	} else {
		return 9;
	}
}

public function isClass(value:*):Boolean
{
	return value instanceof Class;
}

/**
 * ActionScript Object compare
 */
public function equals(a:*, b:*):Boolean
{
	return a === b;
}

