#include <new>
#include <stdio.h>
#include <stdarg.h>
#include <squirrel.h>
#include <sqthread.h>
#include <AS3.h>
#include "asvariant.h"

// sqmain.cpp
extern void sqas_init();
extern int sqas_drive(int diff);
extern void sqas_done();

/**
 * C
 */
int
main(int argc, const char **argv)
{
	sqas_init();
	sqobject::Thread::fork("init.nut", argc, argv);
	AS3Variant getTimer = AS3Variant::createFunction("flash.utils.getTimer");
	// C[v
	unsigned int prevTick   = (int)getTimer.call();
	bool working = true;
	while (working) {
		unsigned int tick = (int)getTimer.call();
		int diff = tick - prevTick;
		if (sqas_drive(diff)<= 0) {
			working = false;
		}
		prevTick = tick;
		flyield();
	}
	sqas_done();
	return 0;
}
