__asm__(
"/**\n"
" * get type information of ActionScript class\n"
" */\n"
"public class TypeParser {\n"
"	\n"
"	public function TypeParser() {\n"
"	}\n"
"\n"
"	public function getAccess(access:String):int {\n"
"		var n:int;\n"
"		if (access == \"readonly\") {\n"
"			n = 1;\n"
"		} else if (access == \"writeonly\") {\n"
"			n = 2;\n"
"		} else {\n"
"			n = 3;\n"
"		}\n"
"		return n;\n"
"	}\n"
"	\n"
"	public function getTypeInfo(objClass:Class):Array {\n"
"		var result:Array = new Array();\n"
"		var typeInfo:XML = flash.utils.describeType(objClass);\n"
"		// class\n"
"		for each (var info:XML in typeInfo.factory.extendsClass) {\n"
"			result.unshift(new Array(1, info.@type));\n"
"		}\n"
"		// static\n"
"		for each (var info:XML in typeInfo.accessor) {\n"
"			result.unshift(new Array(2, info.@name, getAccess(info.@access)));\n"
"		}\n"
"		for each (var info:XML in typeInfo.method) {\n"
"			result.unshift(new Array(3, info.@name));\n"
"		}\n"
"		// instance\n"
"		for each (var info:XML in typeInfo.factory.accessor) {\n"
"			result.push(new Array(4, info.@name, getAccess(info.@access)));\n"
"		}\n"
"		for each (var info:XML in typeInfo.factory.method) {\n"
"			result.push(new Array(5, info.@name));\n"
"		}\n"
"		return result;\n"
"	}\n"
"}\n"
);
